;Example program for PIC16C84, by Trevor Brown
;Will increment LED's connected to bits 0-3 of port B (pins 6 to 9)

#DEFINE PAGE0 BCF $03,5
#DEFINE PAGE1 BSF $03,5

        .AVSYM
STATUS: .EQU $03        ;Located in page 0 & 1
PCL:    .EQU $02        ;0 & 1
TMR0:   .EQU $01        ;0
PORTA:  .EQU $05        ;0
PORTB:  .EQU $06        ;0
TRISA:  .EQU $05        ;1   
TRISB:  .EQU $06        ;1
OPTION: .EQU $01        ;1
INTCON: .EQU $0B        ;0 & 1
EEDATA: .EQU $08        ;0
EEADR:  .EQU $09        ;0                    
EECON:  .EQU $08        ;1
PCLATH: .EQU $0A        ;0 & 1

COUNT1: .EQU $0C        ;Register C
COUNT2: .EQU $0D        ;Register D
 
W:      .EQU 0  ;Result to go into working register (accumulator)
F:      .EQU 1  ;Result to go into a file register.

C:      .EQU 0  ;Carry flag  (located in STATUS register)
DC:     .EQU 1  ;Digit carry            "    
Z:      .EQU 2  ;Zero flag              "
PD:     .EQU 3  ;Power Down bit         "
TO:     .EQU 4  ;Time-out bit           "

        .ORG $0004      ;Interupt vector address
         GOTO START     ;Jump to interupt service routine on interupt
        .ORG $0005      ;Start of program memory
        ;Above lines must always be present.
        
        PAGE1
        MOVLW $00       ;Load working register (accumulator) with literal 0.
        MOVWF TRISB     ;Configure all port B lines as output
   
        PAGE0
        
START   MOVLW $00   
        CALL WAIT
        MOVLW $01       ;load working register (accumulator) with l
        CALL WAIT       ;Delay routine
        MOVLW $02       ;Next led array
        CALL WAIT
        MOVLW $03       ;Next led array
        CALL WAIT
        MOVLW $04       ;Next led array
        CALL WAIT
        MOVLW $05       ;Next led array
        CALL WAIT
        MOVLW $06       ;Next led array
        CALL WAIT
        MOVLW $06       ;Next led array
        CALL WAIT
        MOVLW $07       ;Last led array
        CALL WAIT
        CALL DLY
        CALL DLY
        CALL DLY
        GOTO  START     ;Start again
        

WAIT    MOVWF PORTB     ;Send w reg to leds
DLY     MOVLW 255       
        MOVWF COUNT1    ;Put 255 in Count1
        MOVWF COUNT2    ;Put 255 in Count2

LOOP    DECFSZ COUNT1,F         ;DECREMENT AND SKIP NEXT LINE IF ZERO
        GOTO LOOP               ;GOTO LOOP IF NOT ZERO

        DECFSZ  COUNT2,F        ;DECREMENT COUNT1 IF COUNT2 IS ZERO
        GOTO LOOP               ;DO INSIDE LOOP AGAIN IF COUNT2 NZ
        RETURN 
        
        .END            ;This command MUST be placed at end of program.
